"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ItemActionButton = void 0;
const react_1 = __importDefault(require("react"));
const emotion_1 = require("@leafygreen-ui/emotion");
const constants_1 = require("./constants");
const small_icon_button_1 = require("./small-icon-button");
function ItemActionButton({ action, icon = react_1.default.createElement(react_1.default.Fragment, null), label, tooltip, iconSize = constants_1.ItemActionButtonSize.Default, onClick, iconClassName, className, iconStyle, isDisabled, 'data-testid': dataTestId, }) {
    return (react_1.default.createElement(small_icon_button_1.SmallIconButton, { key: action, glyph: icon, label: label, title: !tooltip ? label : undefined, size: iconSize, "data-action": action, "data-testid": dataTestId, onClick: onClick, className: (0, emotion_1.cx)(iconClassName, className), style: iconStyle, disabled: isDisabled }));
}
exports.ItemActionButton = ItemActionButton;
//# sourceMappingURL=item-action-button.js.map