import React from 'react';
import type { GlyphName } from '@leafygreen-ui/icon';
export type TabTheme = {
    '--workspace-tab-background-color': string;
    '--workspace-tab-selected-background-color': string;
    '--workspace-tab-top-border-color': string;
    '--workspace-tab-selected-top-border-color': string;
    '--workspace-tab-border-color': string;
    '--workspace-tab-color': string;
    '--workspace-tab-selected-color': string;
    '&:focus-visible': {
        '--workspace-tab-selected-color': string;
        '--workspace-tab-border-color': string;
    };
};
type TabProps = {
    connectionName?: string;
    type: string;
    title: string;
    isSelected: boolean;
    isDragging: boolean;
    onSelect: () => void;
    onClose: () => void;
    iconGlyph: GlyphName | 'Logo' | 'Server';
    tabContentId: string;
    tooltip?: [string, string][];
    tabTheme?: Partial<TabTheme>;
};
declare function Tab({ connectionName, type, title, tooltip, isSelected, isDragging, onSelect, onClose, tabContentId, iconGlyph, tabTheme, ...props }: TabProps & React.HTMLProps<HTMLDivElement>): React.JSX.Element;
export { Tab };
//# sourceMappingURL=tab.d.ts.map